/**
 * Copyright (C) 2001 Billy Biggs.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or (at
 * your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef PATBAR_H_INCLUDED
#define PATBAR_H_INCLUDED

#include <song.h>
#include <chanbar.h>

class PatBar : public ChanBar
{
public:
	PatBar( int initchan, int startrow, int startcol );
	~PatBar( void );

	// Cursor movement.
	int setCursor( int newpos );

	// Screen management.
	void setPosition( int newpos );
	void refresh( void ) const;

	// Song editing.
	bool patternSet( void ) const
		{ return ( getChannel()->getSongPattern( pos ) != 0 ); }
	void setNote( int note );
	void toggleCursorSlide( void );
	void setPatternName( const char *newname ) const;
	void editCursorVolume( int mod ) const;
	void editPattern( int mod ) const;
	void transposeNotes( int trans ) const;

private:
	int pos;

	void printPatLine( int i ) const;
	void noteToString( char *str, int note ) const;
};

#endif // PATBAR_H_INCLUDED
